/*
 * Ping Pong test classes for Jada
 *
 * Refer to jada.html to know hot to use this file.
 *
 * (C) 1996 Davide Rossi
 */

import jada.*;
import jada.net.*;
import java.applet.Applet;
import java.awt.List;

class Ping implements Runnable {
	//the object space
	ObjectSpace object_space=null;

	public Ping(ObjectSpace ts) {
		object_space=ts;
	}

	/*
	 * the basic in-out loop, we use different Tuple contructors here
	 */
	public void run() {
		while(true) {
			//this tuple matches with any tuple having "ping" as first item
			//and an instance of the class Integer as second one
			Tuple in=(Tuple)object_space.in(new Tuple("ping", Integer.class));
			//get the int vaue of the second field for the tuple returned by in
			int cnt=((Integer)in.getItem(1)).intValue();
			//puts a new tuple into the object space
			object_space.out(new Tuple("pong", new Integer(cnt+1)));
			System.out.println(in);
		}
	}

	public static void main(String args[]) {
		ObjectClient object_space=null;

		//if one arg exists it should be the object server host address
		if(args.length==1) {
			object_space=new ObjectClient(args[0]);
		} else {
			object_space=new ObjectClient();
		}
		new Ping(object_space).run();
	}
}

class Pong implements Runnable {
	//the object space
	ObjectSpace object_space=null;

	public Pong(ObjectSpace ts) {
		object_space=ts;
	}

	public void run() {
		while(true) {
			Tuple in=(Tuple)object_space.in(new Tuple("pong", Integer.class));
			int cnt=((Integer)in.getItem(1)).intValue();
			object_space.out(new Tuple("ping", new Integer(cnt+1)));
			System.out.println(in);
		}
	}

	public static void main(String args[]) {
		ObjectClient object_space=null;

		//if one arg exists it should be the object server host address
		if(args.length==1) {
			object_space=new ObjectClient(args[0]);
		} else {
			object_space=new ObjectClient();
		}
		object_space.out(new Tuple("ping", new Integer(0)));
		new Pong(object_space).run();
	}
}

public class PingPong {
	public static void main(String args[]) {
		//create a new (local) object space
		ObjectSpace object_space=new ObjectSpace();
		//run the ping thread
		new Thread(new Ping(object_space)).start();
		//run the pong thread
		new Thread(new Pong(object_space)).start();
		//put a first item in the object space
		try {
			object_space.out(new TupleString("(ping, 0)"));
		} catch(Throwable t){}
	}
}
